This is an unstructured list of web-sites I find interesting. I keep them here rather than as a collection of browser bookmarks as I find this format easier to structure. Some get pulled into more structured articles as references or 'further reading' and eventually removed from this list. So in a way, this is sort of a 'to-do list' or staging area.

# Tech compilations #

* [Digital Superpowers](https://digitalsuperpowers.com/book/)
* [Arch overview open source](https://aosabook.org/en/index.html)
* [Build your own x](https://github.com/codecrafters-io/build-your-own-x)
* [My Software Bookshelf](https://olano.dev/blog/my-software-bookshelf/)

# Compilers #

* [LLVM Tutorial](https://llvm.org/docs/tutorial/MyFirstLanguageFrontend/index.html)
* [Resource compiler](https://vector-of-bool.github.io/2017/01/21/cmrc.html)
* [Bison](https://www.gnu.org/software/bison/manual/bison.html)
* [ELF Format](https://4zm.org/2024/12/25/a-simple-elf.html)

# Assembly #

* [Asm hello world](https://jameshfisher.com/2018/03/10/linux-assembly-hello-world/)
* [Linux syscall list](https://github.com/torvalds/linux/blob/master/arch/x86/entry/syscalls/syscall_64.tbl)

# Languages #

* [Python module of the week](https://pymotw.com/3/)
* [Lesser known parts of the Python standard library](https://www.trickster.dev/post/lesser-known-parts-of-python-standard-library/)
* [OCaml Book](https://cs3110.github.io/textbook/chapters/preface/about.html)
* [C Coding Style](https://nullprogram.com/blog/2023/10/08/#strings)
* [Language power with Racket](https://lambdaland.org/posts/2024-11-21_powerful_or_safe_languages/)

# File Formats #

* [Zlib spec](https://datatracker.ietf.org/doc/html/rfc1950)
* [zlib overview](https://marknelson.us/posts/1997/01/01/zlib-engine.html)
* [PNG spec](http://www.libpng.org/pub/png/spec/1.2/png-1.2.pdf)
* [Deflate spec](https://www.rfc-editor.org/rfc/rfc1951.pdf)
* [png tutorial](http://zarb.org/~gc/html/libpng.html)

# File Systems #

* [Lustre](https://www.highgo.ca/2022/07/22/how-to-setup-lustre-file-system-and-run-postgres-on-it/)

# Data Structures #

* [Implementing a vector](https://www.cs.odu.edu/~zeil/cs361/latest/Public/vectorImpl/index.html)

# Shell #

* [Introduction to bash scripting](https://github.com/bobbyiliev/introduction-to-bash-scripting)
* [Command Line Interface Guidelines](https://clig.dev/#help)
* [Terminal text](https://jvns.ca/blog/2024/07/08/readline/)
* [TTY demystified](http://www.linusakesson.net/programming/tty/index.php)
* [Write a shell in C](https://brennan.io/2015/01/16/write-a-shell-in-c/)
* [Mac CLI Tips](https://weiyen.net/articles/useful-macos-cmd-line-utilities/)
* [Command line tools](https://rwblickhan.org/newsletters/command-line-tools-i-like-2022/)

# Graphics #

* [Polygons and meshes](https://paulbourke.net/geometry/polygonmesh/)
* [xcb](https://www.x.org/releases/X11R7.6/doc/libxcb/tutorial/index.html)
* [xcb](https://xcb.freedesktop.org/tutorial/)
* [opengl](https://xcb.freedesktop.org/opengl/#index5h1)
* [opengl](https://www.linuxjournal.com/content/introduction-opengl-programming)
* [cool animations](https://bleuje.com/animationsite/2023_1/)
* [Ocean waves](https://github.com/2Retr0/GodotOceanWaves)

# Audio #

* [Midi format](http://www.personal.kent.edu/~sbirch/Music_Production/MP-II/MIDI/midi_file_format.htm)
* [midi format](https://web.archive.org/web/20141227205754/http://www.sonicspot.com:80/guide/midifiles.html)
* [Midi format](http://www.music.mcgill.ca/~ich/classes/mumt306/StandardMIDIfileformat.html)
* [alsa](https://alsa-project.org/wiki/Tutorials_and_Presentations)

# Text Editors #

* [Sysadmin guide to vim](https://www.linuxfoundation.org/blog/blog/classic-sysadmin-vim-101-a-beginners-guide-to-vim)
* [Sample emacs config](https://protesilaos.com/codelog/2024-11-28-basic-emacs-configuration/)
* [Email in emacs](https://leon_plickat.srht.site/writing/painless-mail-imaps-smtp-gnus-emacs/article.html)

# Networking #

* [sockets](https://www.cs.rpi.edu/~moorthy/Courses/os98/Pgms/socket.html)
* [http made easy](https://www.jmarshall.com/easy/http/)
* [Wireguard for private network](https://taggart-tech.com/wireguard/)
* [Sysadmin tools](https://mwl.io/nonfiction/tools)

# Database #

* [Writing a kv store](https://mrkaran.dev/posts/barreldb/)

# Containers #

* [Linux containers](https://optimizedbyotto.com/post/linux-containers-docker/)

# Web #

* [Drawing divs](https://alignedleft.com/tutorials/d3/drawing-divs)
* [Dockerizing Django](https://testdriven.io/blog/dockerizing-django-with-postgres-gunicorn-and-nginx/)

# Database #

* [Database storage structures](https://en.wikipedia.org/wiki/Database_storage_structures)

# Publishing #

* [A Few Notes on Book Design](https://texdoc.org/serve/memdesign/0)
* [MathMl fonts](https://developer.mozilla.org/en-US/docs/Web/MathML/Fonts)
* [Text rendering](https://behdad.org/text2024/)
* [The Visual Display of Quantitative Information](https://www.amazon.co.uk/Visual-Display-Quantitative-Information/dp/0961392142)

# Architecture and Design #

* [Clean Coder Blog](https://blog.cleancoder.com/uncle-bob/2012/08/13/the-clean-architecture.html)

# Security #

* [Fuzzing GStreamer](https://github.blog/security/vulnerability-research/uncovering-gstreamer-secrets/)

# Maths #

* [The Matrix Cookbook](https://www.math.uwaterloo.ca/~hwolkowi/matrixcookbook.pdf)
* [The Tensor Cookbook](https://tensorcookbook.com/)

# Machine Learning #

* [MLE](https://rish-01.github.io/blog/posts/ml_estimation/)
* [Gradient Descent Overview](https://www.ruder.io/optimizing-gradient-descent/)
* [Generative Models Overview](https://nrehiew.github.io/blog/2024/)

# Linked Data #

* [DOI URI Scheme](https://ws-dl.blogspot.com/2024/11/2024-11-13-doi-uri-scheme-utility-or.html)

# Games #

* [Flappy Bird C Clone](https://github.com/alxyng/flappybird)

# Operating Systems #

* [Unix History](http://crn.hopto.org/unix/)


# Live and Minimalist Computing #

* [Emacs like editor on steroids](https://albertzak.com/run-build-grow/)
* [Direnv and .envrc files](https://offby1.website/posts/uv-direnv-and-simple-envrc-files.html)


# Hardware #

* [Making an analogue synth](https://www.peterzimon.com/hog/)

# Gardening #

* [Planning a vegetable garden for beginners](https://www.youtube.com/watch?v=9R-utqpmwmE)

